package nc.bs.mmpac.pickm.pfxx.plugin;

import nc.bs.framework.common.NCLocator;
import nc.bs.pfxx.ISwapContext;
import nc.bs.pfxx.plugin.AbstractPfxxPlugin;
import nc.itf.mmpac.pickm.IPickmMaintainService;
import nc.vo.mmpac.pickm.entity.AggPickmVO;
import nc.vo.pfxx.auxiliary.AggxsysregisterVO;
import nc.vo.pfxx.util.PfxxPluginUtils;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.pub.PubAppTool;

/**
 * ϼƻⲿϵͳʵ
 * 
 * @since 6.0
 * @version 2013-10-29 04:29:08
 * @author lijbe
 */
public class MMPacPickmPfxxPlugin extends AbstractPfxxPlugin {
    private IPickmMaintainService maintainService = null;

    @Override
    protected Object processBill(Object vo, ISwapContext swapContext, AggxsysregisterVO aggvo) throws BusinessException {
        // 1.õתVO,ȡ򵼵һעVOϢ
    	
        AggregatedValueObject resvo = (AggregatedValueObject) vo;

        String vopk = PfxxPluginUtils.queryBillPKBeforeSaveOrUpdate(swapContext.getBilltype(), swapContext.getDocID());

        // 2.˵ûеô׼µݣ浥ǰбҪݼ飬ȷҵ쳣...
        AggregatedValueObject returnVO = null;

        if (PubAppTool.isNull(vopk)) {
            resvo.getParentVO().setStatus(VOStatus.NEW);
            for (CircularlyAccessibleValueObject bvo : resvo.getChildrenVO()) {
                bvo.setStatus(VOStatus.NEW);
            }
            returnVO = this.getMaintainService().insert(new AggPickmVO[] {
                (AggPickmVO) resvo
            })[0];
            /***************add by ZTH 2022-11-16 ϼƻԶ*******************************/
            returnVO = this.getMaintainService().auditPickm(new AggPickmVO[] {
                    (AggPickmVO) returnVO
                })[0];
           /************************************************************************************/ 
        }
        else {

            returnVO = this.getMaintainService().update(new AggPickmVO[] {
                (AggPickmVO) resvo
            })[0];
        }
        vopk = returnVO.getParentVO().getPrimaryKey();

        PfxxPluginUtils.addDocIDVsPKContrast(swapContext.getBilltype(), swapContext.getDocID(), vopk);

        return vopk;
    }

    public IPickmMaintainService getMaintainService() {
        if (this.maintainService == null) {
            this.maintainService = NCLocator.getInstance().lookup(IPickmMaintainService.class);
        }
        return this.maintainService;
    }
   
}
